﻿
// ---------------------- top of file TextPnl.cs ----------------------
using System;
using System.Windows.Forms;
using System.Drawing;   
using System.Collections.Generic; 
public class TextPanel : Panel { // itself is just a base panel !!! 
    Font smallfont = new Font("ＭＳ ゴシック", 9); // 24 OK  18 OK  
    Brush pagebrush, forebrush, reversebrush, darkbrush; 
    Pen framepen, linepen, columnpen, forepen, reversepen, cursorpen; // for cursor  
    public string fontname; 
    public Font fontA, fontB, font4fA, font4fB; 
    public const float screennecessity = 2.54f / 2.5f; 
    public float fsizeA, fsizeB,fsize4fA, fsize4fB; // 
    public float _IA, Abase,  xstr;
    public int Tbase = 3; 
    public float centershiftW, centershiftEE, centershiftN, centershiftNN, centershiftSS;
    public float centershiftNNN, centershiftSSS, centershiftWWW, centershiftEEE; 
    public OverPanel overpanel; 
	public TextPanel.MyRich rich;
    public Scroll vscrz; 
    public Scroll hscr; 
    Timer timer;
    public TextBank textbank; 
    public MyForm par; 
    bool cursoron; 
    int TBBconv;
    public int delta;  // for mouse wheel !!! 
    public int ETshift, STshift; 
    private int practicalTsize, logicalTsize, _presentpage;
    public bool nowdown;
    static Color colorfore = Color.Black, colorreverse=Color.White; 
    // ######################################################################### 
    public TextPanel(MyForm partf, System.Windows.Forms.Control.ControlCollection controlstf, TextBank textbanktf) { 
        framepen = new Pen(Color.Orange); // frame of each page 
        linepen = new Pen(Color.Bisque); // each line 
        columnpen = new Pen(Color.Yellow); // each column 
        smallfont = new Font("ＭＳ ゴシック", 9); // 24 OK  18 OK  
        pagebrush = new SolidBrush(Color.FromArgb(255, 50, 50, 255)); // page number  
        cursorpen = new Pen(Color.Black,1); // for cursor
        forebrush = new SolidBrush(colorfore); // color of characters 
        forepen = new Pen(colorfore); // underline 
        darkbrush = new SolidBrush(Color.DarkGray); // background when selected 
        reversebrush = new SolidBrush(colorreverse); // color of characters when selected 
        reversepen = new Pen(colorreverse); // underline when selected 
        fontname="ＭＳ ゴシック";
        fsize4fA = float.Parse("14")*4*0.254f; //   
        fsize4fB = float.Parse("14")*7.2f*0.254f; //   
        vscrz = new Scroll(); 
        hscr = new Scroll();  hscr.setinverse(true); 
        cursoron = true; 
        TBBconv = 0;
        delta = 0;  // for mouse wheel !!! 
        ETshift = 0; STshift=0;
        practicalTsize = 0; logicalTsize = 0;
        nowdown = false; 
        _presentpage = 0;  
        par = partf;
        Abase = 23; 
        xstr = Abase - 1;  
        textbank = textbanktf; 
        this.BorderStyle = BorderStyle.Fixed3D; 
        overpanel = new OverPanel(this); 
        overpanel.Location = new Point(2, 0); //  2,0 
		controlstf.Add(this); 
		this.Controls.Add(overpanel); 
        par.Controls.Add(vscrz);
        par.Controls.Add(hscr);
        vscrz.BaseChangedAnyway += (o, e) => { // horizontal case  
            setETshift();  
            overpanel.Refresh();
            
            richtowardcursornonreal(); 

            Refresh(); };
        hscr.BaseChangedAnyway += (o, e) => { 
            setSTshift(); 
            overpanel.Refresh(); 
            
            richtowardcursornonreal(); 

            Refresh(); };
        hscr.MouseWheel +=hscrMouseWheel;  
        vscrz.MouseWheel +=vscrMouseWheel;  
        this.MouseWheel +=vscrMouseWheel; 
        this.MouseWheel +=hscrMouseWheel; 
        setfsize("14"); 
        setfontname("ＭＳ ゴシック"); 
        rich = new TextPanel.MyRich(this);   
        rich.Text = ""; 
        rich.Select(0, 0);  
        rich.Select(); 
		this.Controls.Add( rich ); 
        resize();  
        // 
        timer = new Timer();
        timer.Interval = 500;
        timer.Tick += (o, e) => {
            cursoron = !cursoron;
            Refresh(); };
        timer.Start();  
    } // ========================================================================== 
    // ############################# inner class 1 ################################
    public class OverPanel : Panel {
        TextPanel par; 
        public OverPanel(TextPanel partf) {
            par = partf; 
            DoubleBuffered = true;
            BackColor = Color.Beige;
            Cursor = par.par.cursorhoriz; //  Cursors.IBeam; 
        } // ======================================================= 
        int getiA(MouseEventArgs e) {
            int iA; 
            if (par.par.menu_Mode_Vertical.Checked) { 
                iA = (int)(0.5+ ((e.Y - par.Abase) /(double) TextPanel.IAstat));    
            } else { 
                iA = (int)(0.5+((e.X - par.Abase) /(double) TextPanel.IAstat)); } 
            if(iA < 0) { iA = 0; }  
            return iA;
        } // ==========================================================================  
        int getiT(MouseEventArgs e){ 
            int iT; 
            if (par.par.menu_Mode_Vertical.Checked) { 
                iT =(int)( (par.STshift-e.X)/TextPanel.ITstat);  
            } else {  
                iT =(int)( (e.Y +par.ETshift) / TextPanel.ITstat); }  
            if(iT < 0) { iT = 0; }
            return iT; 
        } // ==========================================================================  
        protected override void OnMouseDown(MouseEventArgs e) {  
            int iA = getiA(e), iT = getiT(e); 
            int idnhere = par.par.textbank.getifromiAiTip(iA, iT, par.presentpage); 
            par.par.textbank.setidn(idnhere);  
            par.nowdown = true; 
            par.overpanel.Refresh(); 
        } // ==========================================================================  
        protected override void OnMouseMove(MouseEventArgs e) {
            if (!par.nowdown) { return; } 
            int iA = getiA(e), iT = getiT(e); 
            int iuphere = par.par.textbank.getifromiAiTip(iA, iT, par.presentpage); 
            par.par.textbank.setiup(iuphere); 
            par.overpanel.Refresh(); 
        } // ==========================================================================  
        protected override void OnMouseUp(MouseEventArgs e) {
            OnMouseMove(e); 
            par.nowdown = false; 
            par.rich.Text = ""; 
            par.rich.Select(0, 0);  
            par.rich.Select(); 
            if (par.par.textbank._iL < par.par.textbank._iR) { par.par.controlPanel.showeffectbuttons(); } 
            if (par.par.textbank._iL == par.par.textbank._iR) { par.par.controlPanel.hideeffectbuttons(); } 
            Refresh(); 
        } // ==========================================================================  
        protected override void OnPaint(PaintEventArgs e) {
            Font ff = par.fontA; 
            par.onpaint(e);  
        } // ========================================================================== 
    } // ##############################################################################  
    public void onpaint(PaintEventArgs e) {  // for text editor 
        textbank.Step2();   
        if (textbank.TBB != TBBconv) { TBBconv = textbank.TBB; resize(); }  
        Graphics g = e.Graphics;
        if (!par.menu_Mode_Vertical.Checked) { 
            g.TranslateTransform(Abase, -ETshift);
            ContinuHoriz(g, ETshift, ETshift+this.Height); // === in TextPanel2 !!! 
            // ########################## cursor ###########################  
            if (textbank.getcursori() >= 0 && cursoron) { 
                float x = textbank.placeLs[textbank.getcursori()].A * IAstat, 
                        ii = textbank.placeLs[textbank.getcursori()].Ttotal; 
                g.DrawLine(cursorpen, x , ii * ITstat+1 , x , (ii+1) * ITstat-1); }  
        } else {
            g.TranslateTransform(STshift, Abase);
            ContinuVerti(g, STshift-this.Width, STshift); // === in TextPanel2 !!! east, west 
            // ########################## cursor ###########################  
            if (textbank.getcursori() >= 0 && cursoron) { 
                float y = textbank.placeLs[textbank.getcursori()].A * IAstat, 
                        ii = textbank.placeLs[textbank.getcursori()].Ttotal; 
                g.DrawLine(cursorpen , -((ii+1) * ITstat-1) , y , -(ii* ITstat+1), y); }   
        } 
        par.Invalidate();  
    } // ========================================================================== 
    static float getGraphicWidth(Graphics g, char chr, Font font) {
        string str = chr.ToString(); 
        StringFormat format = StringFormat.GenericTypographic;   
        CharacterRange[] rangeall=new CharacterRange[]{ new CharacterRange(0,1) }; // === length = 1 !!!  
        format.SetMeasurableCharacterRanges(rangeall); 
        Region[] regionall=g.MeasureCharacterRanges(str, font, new Rectangle(0,0,100,100), format);   
        RectangleF recthere=regionall[0].GetBounds(g); // === GetBounds gives each rectangle !!!   
        return recthere.Width; 
    } // ========================================================================== 
    public void richtowardcursornonreal() {
        if (textbank._iL == -1) { rich.Location = new Point(0, -30); return; }  
        if (textbank._iL == textbank._iR) { 
            int ii = textbank.placeLs[textbank._iL].Ttotal, i1 = textbank.placeLs[textbank._iL].A;
            float fonsloc = fsizeA * 0.84f; 
            if (par.menu_Mode_Vertical.Checked) {  
                rich.Location = new Point((int)(STshift -(ii+0.5f)*ITstat-21) , (int)((i1+0.5f) * IAstat + Abase -fonsloc-1));
            } else { 
                rich.Location = new Point((int)((i1+0.5f) * IAstat + Abase-fonsloc-3), (int)((ii+0.5f)*ITstat - ETshift-centershiftN-2  )); } 
        } 
    } // ==========================================================================  
    
    public const float IAstat = 5*4f; 
    public const float ITstat=9.0f*4f;
    public float F=14f;  
    public void setsizesLS() { // continuous editor !!! 
        setfsize("14");  
        finishsize(); // ++++++++++
    } // ==========================================================================  
    public void setfsize(string str) { // of textpanel 
        F = float.Parse(str); 
    } // ==========================================================================  
    public void setfontname(string fontnametf) { 
        fontname = fontnametf; 
        font4fA = new Font(fontname, fsize4fA); // fixed 
        if (fsizeA > 0) { 
            finishsize(); } 
    } // ========================================================================== 
    public void prepsizeconti() { // finishsize follows 
        fsizeA = fsize4fA;
        fsizeB = fsize4fB;  
        finishsize(); 
    } // ==========================================================================   
    public void setfontdesign() {  
        fsizeA = F*2*0.254f;  
        fsizeB = F*3.6f*0.254f;    
        finishsize();   
    } // ==========================================================================   
    public void setfontprint() { // finishsize follows 
        fsizeA = F*4*0.254f; 
        fsizeB = F*7.2f*0.254f; 
        finishsize(); 
    } // ========================================================================== 
    public void finishsize() { // === printpage, 
        fontA = new Font(fontname, fsizeA); // fixed 
        fontB = new Font(fontname, fsizeB); // fixed 
        centershiftN=fsizeA*0.5f; // of usual str; to subst  --------  all from center !!! 
        centershiftNN = fsizeA * 1.4f; // of accent str; to subst 
        centershiftSS= fsizeA*0.9f; // of under line; to add 
        centershiftSSS = fsizeA * 1.2f;  centershiftNNN = fsizeA * 1.3f; // 1.4f max 
        centershiftW = fsizeA * 1.2f;  
        centershiftEE = fsizeA * 0.5f; // vertical side line
        centershiftWWW = fsizeA * 1.3f; centershiftEEE = fsizeA * 1.2f; 
    } // ========================================================================== 
    private void setSTshift() { 
        STshift = (int)(Width - 6 - Tbase + hscr.getbase()); 
    } // ========================================================================== 
    private void setETshift() { 
        if (par.menu_Mode_Design == null) { return; } 
        if (!par.menu_Mode_Design.Checked) { 
            ETshift = (int)(vscrz.getbase()-Tbase);  } 
    } // ==========================================================================  
    protected override void OnSizeChanged(EventArgs e) {
        setETshift(); 
        setSTshift(); 
    } // ==========================================================================  
    public void callpurgetext(string str)  {
        textbank.purgetext(str);  
        rich.Text = ""; 
        rich.Select(0, 0);  
        rich.Select();
        Refresh(); 
    } // ========================================================================== 
    public void vscrMouseWheel(object o, MouseEventArgs e) { 
        if (!par.menu_Mode_Design.Checked) { 
            delta=e.Delta;
            int vtoset=vscrz.getbase() - delta*3 / 5;
            if (vtoset > vscrz.getwhole()-vscrz.getview()) { 
                vtoset = vscrz.getwhole() - vscrz.getview(); } 
            if (vtoset < 0) { vtoset = 0; }
            vscrz.setbase(vtoset); 
            delta = 0; } 
    } // ========================================================================== 
    public void hscrMouseWheel(object o, MouseEventArgs e) { 
        delta=e.Delta;
        int vtoset=hscr.getbase() - delta*3 / 5;
        if (vtoset > hscr.getwhole()-hscr.getview()) { 
            vtoset = hscr.getwhole() - hscr.getview(); } 
        if (vtoset < 0) { vtoset = 0; }
        hscr.setbase(vtoset); 
        delta = 0; 
    } // ========================================================================== 
    public void resize() { // rebuild table according controllerpanel's NA and NT !!! 
        if (par.menu_Mode_Design == null || (par.menu_Mode_Design.Checked) ) { return; } 
        logicalTsize= (int)(textbank.TBB * ITstat + Tbase * 2+6);  // 
        if (par.menu_Mode_Vertical.Checked) {  
            practicalTsize=par.ClientRectangle.Width - 4; 
            vscrz.Hide(); 
            this.overpanel.Height=this.Height=(int)(IAstat*par.getNA()+Abase*2+4); 
            if (logicalTsize <= practicalTsize) { // === within 
                this.overpanel.Width=Width = logicalTsize; 
                hscr.Hide();
                hscr.setbase(0);   
                setSTshift(); 
            } else { 
                this.overpanel.Width = Width = practicalTsize; 
                hscr.Show(); 
                hscr.SetBounds(2, getidealscrAverti(), practicalTsize-20, 20); 
                hscr.setview(practicalTsize);
                hscr.setwhole(logicalTsize);
            }
            int formhtobe = getidealformAverti();
            par.minimulwidth = 100; 
            par.minimulheight = formhtobe; // also maximum 
            if (par.ClientSize.Height != formhtobe) { 
                par.ClientSize=new Size(par.ClientSize.Width, formhtobe); 
            }
        } else {
            practicalTsize=par.ClientRectangle.Height - 55-2; 
            hscr.Hide(); 
            this.overpanel.Width=this.Width=(int)(IAstat*par.getNA()+Abase*2+4);  
            if (logicalTsize <= practicalTsize) { // === within 
                this.overpanel.Height=Height = logicalTsize;  
                vscrz.Hide();
                vscrz.setbase(0);  
                setETshift(); // VTshift = Width - 6 - TextPanel.Tbase + HTshift; 
            } else { 
                this.overpanel.Height = Height = practicalTsize; 
                vscrz.Show(); 
                vscrz.SetBounds(getidealscrAhoriz(), 58, 20, practicalTsize-20); 
                vscrz.setview(practicalTsize);
                vscrz.setwhole(logicalTsize);
            }
            int formwtobe = getidealformAhoriz();
            par.minimulheight = 100; 
            par.minimulwidth = formwtobe; 
            if (par.ClientSize.Width < formwtobe) {
                par.ClientSize=new Size(formwtobe, par.ClientSize.Height);
            } 
        } 
        Invalidate();
        overpanel.Refresh(); 
        Refresh();  
    } // =================================================== 
    public int getidealformAhoriz() {
        return getidealscrAhoriz() + 21; 
    } // ==========================================================================  
    public int getidealformAverti() {
        return getidealscrAverti()+21; 
    } // ==========================================================================  
    public int getidealscrAhoriz() {
        return (int)(2 + IAstat * par.getNA() + Abase * 2 + 2); 
    } // ==========================================================================  
    public int getidealscrAverti() {
        return (int)(55 + IAstat * par.getNA() + Abase * 2 + 4); 
    } // ==========================================================================  
    public int presentpage { 
        get{ 
            return _presentpage; } 
        set{ 
            _presentpage = value;   
        } 
    } // ==========================================================================  
    // ############################# inner class 2 ################################
    public  class MyRich : TextBox {
        List<int> li = new List<int>();  
        TextPanel tpanel; 
        public void addclipboard() { // === 長文貼付
		    this.Multiline = true; 
            tpanel.textbank.setcursori(-1);
            MessageBox.Show("貼付け位置を指定し、続いて ctrl-V してください！！！"); 
        } // =========================================================  
        protected override void OnPreviewKeyDown(PreviewKeyDownEventArgs e) { 
            tpanel.textbank.Step1edit((char)e.KeyCode); // all key input are first accepted here !!! 
        } // =========================================================  
        public MyRich (TextPanel tpaneltf) { 
            tpanel = tpaneltf;
            this.Multiline = true; // false; ***  
		    Size=new Size(260,30); // 33*16 = 528 
		    this.WordWrap=false; // false : === automatic horizontal scroll !!! 
		    this.Font = tpaneltf.font4fA; 
		    this.TextChanged += (o, e) => {
                tpanel.par.edited = true; 
			    int ss = this.SelectionStart; 
			    if (ss > 0) { // characters are added one by one !!! 12832 12848 
                    string str = this.Text;
                    int ii = (int)str[0];
                    string strcp = tocp(str); 
                    if (strcp == "\n") { 
                        strcp = ""; } // ***  
                    tpanel.textbank.regionalreplace0(strcp); // tpanel.text and modification are treated 
				    tpanel.textbank.setcursoripre(tpanel.textbank._iL + strcp.Length);  
				    this.Text = ""; 
				    tpanel.overpanel.Refresh(); } 
            }; 
        } // ========================================================== 
        public string tocp(string str) {
            string strcp = ""; 
            for (int i=0; i<str.Length; i++) { 
                char chere = str[i];
                if (chere != '\r') { 
                    strcp += chere.ToString(); } } 
            return strcp; 
        } // ========================================================== 
    } // ##############################################################   
	public void ContinuHoriz(Graphics g, int yceiling, int yfloor) { // === for text editor !!! 
        int NA = par.getNA(); 
        // ############################################################## 
        float IA = IAstat, IT = ITstat;
        float w0 = getGraphicWidth(g, '﹅', fontA); 
        float ycc = (yceiling - 2*w0)/(float)IT, yff = (yfloor + w0)/(float)IT;
        float tlim = 0, blim = textbank.TBB; 
        if (tlim<ycc) { tlim = ycc; } 
        if (blim>yff) { blim = yff; } 
        for (int ix=0; ix<=par.getNA(); ix++) {  
            g.DrawLine(columnpen, IA*ix, IT*tlim, IA*ix, IT*blim); }  
        for (int p=0; p<textbank.pls.Count; p++) { // -1 because pls added one 
            int yT = textbank.pls[p], yB = textbank.pls[p] + par.getNT(), yNext=yB; // yNext=pls[p].Lbottom; 
            // =========== hurry up devices ================= 
            if (yB<ycc) { continue; } 
            if (yT>yff) { break; } 
            // ============================================== 
            double rate = 1.0; 
            if (p < textbank.pls.Count-1) { 
                yNext = textbank.pls[p + 1]; 
                rate = (textbank.pls[p+1]-textbank.pls[p]) / (double)par.getNT(); } 
            int mpre=20, npre=2, mpost=20,npost=2, 
                inoseepre = (int)(mpre*(1-rate) + npre*rate), 
                inoseepost = (int)(mpost*(1-rate) + npost*rate); 
            if (p == textbank.pls.Count-1) { inoseepre = npre;  yNext = yB;                      // S 
                g.DrawLine(framepen, -npre, IT*yB, IA*NA+mpost, IT*yB); 
            } else {    
                g.DrawLine(framepen, IA*NA+inoseepost, IT*yB, IA*NA+mpost, IT*yB); } 
            g.DrawLine(framepen, -mpre, IT*yT, IA*NA+npost, IT*yT); // *** 20 N 
            g.DrawLine(framepen, IA*NA+npost, IT*yT, IA*NA+mpost, IT*yB);  // E
            g.DrawLine(framepen, -mpre, IT*yT, -inoseepre, IT*yNext);  // W 
            g.DrawString((p+1).ToString(), smallfont, pagebrush, -16, IT*yT+5);
            for (int y=yT+1; y<yNext; y++) {  
                g.DrawLine(linepen, 0, IT*y, IA*NA, IT*y); } } // *** 20 
        // ############################################################## 
        for (int i=textbank.getiL(); i<textbank.getiR(); i++) { 
            int w = (int)(textbank.wofi[i]*IA); 
            TextBank.TextPlace tp = textbank.placeLs[i]; 
            g.FillRectangle(darkbrush, tp.A* IA , tp.Ttotal* IT, w, IT); }
        // ##############################################################   
        horizcommon(g, 0, IA, IT, ycc, yff); 
	} // ==========================================================================   
	public void DesignHoriz(Graphics g, int page, int nfold) { // === design and print !!! 
        decimal sa = par.getSA(), st = par.getST(); // 歩幅、行階高
        float IA = (float)(sa*nfold), IT = (float)(st*nfold); // IA==2(4)*walk(mm)  IT=2(4)*stries(mm) 
        if (page > textbank.pls.Count) {
            MessageBox.Show("最終は"+textbank.pls.Count.ToString()+"ページです。"); return; }
        int pt = textbank.pls[page-1], pe=pt+100; 
        if (page<textbank.pls.Count) {pe=textbank.pls[page]; } 
        // 
        float ww = par.getNA() * IA;
        Pen linepen = new Pen(par.linecolor); 
        for (int i=0; i<par.getNT(); i++) { 
            g.DrawLine(linepen, 0 , (i + 0.5f) * IT +  centershiftSSS,
                                    ww , (i + 0.5f) * IT + centershiftSSS); 
            g.DrawLine(linepen, 0 , (i + 0.5f) * IT - centershiftNNN,
                                    ww , (i + 0.5f) * IT - centershiftNNN); 
            for (int j=1; j<par.getNA(); j++) {
                float w = j * IA; 
                g.DrawLine(linepen, w , (i + 0.5f) * IT - centershiftNNN,
                                        w , (i + 0.5f) * IT + centershiftSSS); } } 
        for (int i=0; i<=par.getNA(); i+=par.getNA()) {
            float ii = i * IA, jjm = par.getNT();
            g.DrawLine(linepen, ii , 0.5f * IT - centershiftNNN,
                                    ii , (jjm-1 + 0.5f) * IT + centershiftSSS); }   
        // 
        horizcommon(g, textbank.pls[page-1], IA, IT, pt, pe); 
	} // ========================================================================== 
    void horizcommon(Graphics g, int line0, float IA, float IT, float ycc, float yff) { // ycc:total line of page top  
        for (int i=0; i<textbank.text.Length; i++) {  
            string str = textbank.text.Substring(i, 1); 
            if (str == "\n" || str == "\f") { continue; }  
            TextBank.TextPlace tp=textbank.placeLs[i]; 
            // =========== hurry up devices ================= 
            if (tp.Ttotal<ycc) { continue; } 
            if (tp.Ttotal>=yff) { break; } 
            // ============================================== 
            float w3 = getGraphicWidth(g, str[0], fontA), cmpare = w3 * 0.48f+fsizeA * 0.2f; 
            int yinpage=tp.Ttotal - line0;              // 
            Brush brushhere = forebrush; 
            Pen penhere = forepen;
            if (i >= textbank.getiL() && i < textbank.getiR()) { // === case region is selected by mouse !!!  
                brushhere = reversebrush; 
                penhere = reversepen; } 
            float ces = 0.5f * fsizeA; 
            g.DrawString(str, fontA, brushhere, IA*(tp.A + textbank.wofi[i]*0.5f)-cmpare, (yinpage+0.5f) * IT-ces);

            if ( (textbank.modifs[i] & 1) > 0 ) {
                g.DrawLine(penhere, tp.A * IA , (yinpage + 0.5f) * IT +  centershiftSS,
                                        (tp.A + 1) * IA , (yinpage + 0.5f) * IT + centershiftSS); }
            int iemph = textbank.modifs[i] & 14; 
            if ( iemph > 0 ) { 
                string stremph=("﹅").ToString(); // 0xfe45
                float yshift=fsizeA*2.1f; 
                if (iemph == 4) { 
                    stremph=("﹆").ToString();  // 0xfe46 
                } else if (iemph == 6) { 
                    stremph=("•").ToString();  // 0x2022 
                } else if (iemph == 8) { 
                    stremph=("◦").ToString();  } // 0x25e6 
                float w4 = getGraphicWidth(g, stremph[0], fontA), cshift = w4 * 0.8f+fsizeA * 0.5f;  
                g.DrawString(stremph, fontB, brushhere, IA*(tp.A + textbank.wofi[i]*0.5f)-cshift, 
                                                                (yinpage+0.5f) * IT-yshift); } } 
	} // ========================================================================== 
	public void ContinuVerti(Graphics g, int xeast, int xwest) { // === for text editor !!!  
        int NA = par.getNA(); 
        float IA = IAstat, IT = ITstat; 
        float w0 = getGraphicWidth(g, '﹅', fontA), w2 = getGraphicWidth(g, '•', fontA);  
        float xe = (xeast - 2*w0)/(float)IT, xw = (xwest + w0)/(float)IT; // .. < 0  
        // ############################################################## 
        float wlim = textbank.TBB, elim = 0; 
        // =========== hurry up devices ================= 
        if (elim>-xe) { elim=-xe; } 
        if (wlim<-xw) { wlim=-xw; } 
        // ============================================== 
        for (int iy=0; iy<=NA; iy++) {  
            g.DrawLine(columnpen, -(IT*wlim), IA*iy, -IT*elim, IA*iy); } 
        for (int p=0; p<textbank.pls.Count; p++) { // -1 because pls added one 
            int xT = textbank.pls[p], xB = textbank.pls[p] + par.getNT(), xNext = xB; // xNext=pls[p].Lbottom; 
            // =========== hurry up devices ================= 
            if (xB<xe) { continue; } 
            if (xT>xw) { break; } 
            // ============================================== 
            double rate = 1.0; 
            if (p < textbank.pls.Count-1) { 
                xNext = textbank.pls[p + 1]; 
                rate = (textbank.pls[p+1]-textbank.pls[p]) / (double)par.getNT(); } 
            int mpre=20, npre=2, mpost=20,npost=2,
                inoseepre = (int)(mpre*(1-rate) + npre*rate), 
                inoseepost = (int)(mpost*(1-rate) + npost*rate); 
            if (p == textbank.pls.Count-1) { inoseepre = npre;  xNext = xB; 
                g.DrawLine(framepen, -(IT*xB), -npre, -(IT*xB), IA*NA+mpost); 
            } else {    
                g.DrawLine(framepen, -(IT*xB), IA*NA+inoseepost, -(IT*xB), IA*NA+mpost); } 
            g.DrawLine(framepen, -(IT*xT), -mpre, -(IT*xT), IA*NA+npost); // *** 20 N E
            g.DrawLine(framepen, -(IT*xT), +IA*NA+npost, -(IT*xB), IA*NA+mpost);  // E N
            g.DrawLine(framepen, -(IT*xT), -mpre, -(IT*xNext), -inoseepre);  // W S
            g.DrawString((p+1).ToString(), smallfont, pagebrush, -(IT*xT+19), -16);
            for (int x=xT+1; x<xNext; x++) {  
                g.DrawLine(linepen, -(IT*x), 0, -(IT*x), IA*NA); } } // *** 20  
        // ############################################################## 
        for (int i=textbank.getiL(); i<textbank.getiR(); i++) { 
            int w = (int)(textbank.wofi[i]*IA); 
            TextBank.TextPlace tp = textbank.placeLs[i]; 
            g.FillRectangle(darkbrush , -((tp.Ttotal+1)* IT), tp.A* IA, IT, w); } 
        // ############################################################## 
        verticommon(g, 0, IA, IT, xe, xw, "edit"); 
	} // ========================================================================= 
	public void DesignVerti(Graphics g, int page, int nfold, string strmode) { // === "design" and "print" !!!   
        decimal sa = par.getSA(), st = par.getST(); 
        float IA = (float)(sa*nfold), IT = (float)(st*nfold); // IA==2(4)*walk(mm)  IT=2(4)*stries(mm) 
        if (page > textbank.pls.Count) {
            MessageBox.Show("最終は"+textbank.pls.Count.ToString()+"ページです。"); return; }
        int pt = textbank.pls[page-1], pe=pt+100; 
        if (page<textbank.pls.Count) {pe=textbank.pls[page]; } 
        g.TranslateTransform(IT*par.getNT(), 0); 
        // 
        Pen linepen = new Pen(par.linecolor); 
        float hh = par.getNA() * IA;  
        for (int io=0; io<par.getNT(); io++) {
            int i = io; 
            if (par.menu_Mode_Bag.Checked && i<par.getNT()/2) { i--; }; 
            g.DrawLine(linepen, -(i + 0.5f) * IT -  centershiftWWW, 0, 
                                    -(i + 0.5f) * IT - centershiftWWW, hh); 
            g.DrawLine(linepen, -(i + 0.5f) * IT + centershiftEEE, 0,
                                    -(i + 0.5f) * IT + centershiftEEE, hh); 
            for (int j=1; j<par.getNA(); j++) {
                float h = j * IA; 
                g.DrawLine(linepen, -(i + 0.5f) * IT - centershiftWWW, h,
                                        -(i + 0.5f) * IT + centershiftEEE, h); } } 
        for (int i=0; i<=par.getNA(); i+=par.getNA()) {
            float ii = i * IA, jjm=0;
            if (par.menu_Mode_Bag.Checked) { jjm--; }; 
            g.DrawLine(linepen, -(par.getNT()-1 + 0.5f) * IT - centershiftWWW, ii, 
                                       -(0.5f+jjm) * IT + centershiftEEE, ii); }   
        // 
        verticommon(g, textbank.pls[page-1], IA, IT, pt, pe, strmode); 
	} // ==========================================================================  
    void verticommon(Graphics g,  int line0, float IA, float IT, float xe, float xw, string strmode) { // "print","design","edit"   
        float w0 = getGraphicWidth(g, '﹅', fontA), w2 = getGraphicWidth(g, '•', fontA);  
        int chardifference = (int)((w0 - w2+1) / 2);
        float xstrG=xstr+(IA - w0) / 2; // general shift x  
        StringFormat sf = new StringFormat();
        sf.FormatFlags = StringFormatFlags.DirectionVertical; 
        for (int i=0; i<textbank.text.Length; i++) { 
            string str = textbank.text.Substring(i, 1); 
            if (str == "\n" || str == "\f") { continue; } 
            TextBank.TextPlace tp=textbank.placeLs[i];  
            // =========== hurry up devices ================= 
            if (tp.Ttotal<xe) { continue; } 
            if (tp.Ttotal>=xw) { break; }
            // ============================================== 
            float w3 = getGraphicWidth(g, str[0], fontA), wh=w3/2;  
            int xinpage = tp.Ttotal - line0;  
            if (strmode != "edit" && par.menu_Mode_Bag.Checked && xinpage<par.getNT()/2) { xinpage--; };  
            Brush brushhere = forebrush;
            Pen penhere = forepen; 
            if (i >= textbank.getiL() && i < textbank.getiR()) { // === case region is selected by mouse !!! 
                brushhere = reversebrush;
                penhere = reversepen; }
            float fonsloc = fsizeA * 0.20f; 
            g.DrawString(str, fontA, brushhere, -(xinpage + 0.5f) * IT -centershiftW, (tp.A+textbank.wofi[i]*0.5f) * IA-wh-fonsloc, sf); 
            if ( (textbank.modifs[i] & 1) > 0 ) {
                g.DrawLine(penhere, -((xinpage+0.5f) * IT  - centershiftEE), tp.A * IA + 1
                                ,-((xinpage+0.5f)* IT- centershiftEE), (tp.A + 1) * IA + 1); }
            int iemph = textbank.modifs[i] & 14; 
            if ( iemph > 0 ) {  
                string stremph=("﹅").ToString();  // 0xfe45
                if (iemph == 4) { 
                    stremph=("﹆").ToString();   // 0xfe46 
                } else if (iemph == 6) { 
                    stremph=("•").ToString();   // 0x2022 
                } else if (iemph == 8) { 
                    stremph=("◦").ToString();  } // 0x25e6   
                float xms = 0.0f * fsizeA, yms = 1.2f * fsizeA; 
                float w4 = getGraphicWidth(g, stremph[0], fontA);  
                    g.DrawString(stremph, fontB, brushhere, -(xinpage+0.5f) * IT-xms-w4/1.8f, 
                                (tp.A+textbank.wofi[i]*0.5f) * IA -1.2f*fsizeA); 
            }  
        } 
     } // =========================================================================  
} // ############################################################################## 
// ---------------------- bottom of file TextPnl.cs ----------------------
